#!/usr/local/bin/perl
# 
# Misc utilities for handling SY77 data.
# Copyright (C) 1993 Hiroyuki Ohsaki.
# All rights reserved.
#
# $Id: syutil.pl,v 1.1 1994/02/07 13:17:39 oosaki Exp $
#

sub sy_vseek {
    local(*FILE, $no) = @_;
    seek(FILE, ($no < 48)
	 ? (0x2000 + $no * 0x2d0)
	 : (0xa800 + ($no - 48) * 0x560), 0);
}

sub sy_vread {
    local(*FILE, $no) = @_;
    &sy_vseek(*FILE, $no);
    read(FILE, $_, ($no < 48) ? 0x2d0 : 0x560);
    $_;
}

sub sy_vwrite {
    local(*FILE, $no, $buf, $all) = @_;
    local(@pad) = (0x40, 0x3b, 0x1f, 0x02, 0x00, 0x5d, 0x7f, 0x40,
		   0x40, 0x1f, 0x03, 0x00, 0x66, 0x60, 0x40, 0x40,
		   0x07, 0x02);
    &sy_vseek(*FILE, $no);
    if ($no >= 48) {
	substr($buf, 84, 84) = pack("C*", @pad);
    }
    print FILE $buf;
    if ($all) {
	seek(FILE, 0x10000 + $no * 10, 0);
	print FILE substr($buf, 1, 10);
    }
}

sub sy_mseek {
    local(*FILE, $no) = @_;
    seek(FILE, 0x1000 + $no * 0xaa, 0);
}

sub sy_mread {
    local(*FILE, $no) = @_;
    &sy_mseek(*FILE, $no);
    read(FILE, $_, 0xaa);
    $_;
}

sub sy_mwrite {
    local(*FILE, $no, $buf, $all) = @_;
    &sy_mseek(*FILE, $no);
    print FILE $buf;
    if ($all) {
	seek(FILE, 0x10280 + $no * 20, 0);
	print FILE substr($buf, 0, 20);
    }
}

sub sy_init {
    local(*FILE, $all) = @_;
    local(*INIT);
    open(INIT, $all
	 ? "$ENV{'HOME'}/lib/initall.t"
	 : "$ENV{'HOME'}/lib/initsyn.j");
    while (read(INIT, $_, 1024)) {
	print FILE $_;
    }
    close(INIT);
}

1;
